import time
import sys

from System import Environment
from System import EnvironmentVariableTarget
home = Environment.GetEnvironmentVariable('USERPROFILE', EnvironmentVariableTarget.Process);
path = home+'\\Desktop\\Razor/Scripts'
#Misc.SendMessage(path)
sys.path.append(path)

import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
from System import Byte, Int32
#
#
def whirlwind_available(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if abilities == None:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    if primary == 'Whirlwind Attack':
        Misc.SendMessage("Returning Whirlwing primary", 5)
        return Player.WeaponPrimarySA
    if secondary == 'Whirlwind Attack':
        return Player.WeaponSecondarySA    
    return None

#
#
import re
def weapon_abilities():
    w_r = Player.GetItemOnLayer('RightHand')
    Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    Misc.SendMessage("left={}".format(w_l))
    ret = None
    if w_l != None: 
        ret = common.default_weapon_abilities(w_l.ItemID)         
        if ret[0] or ret[1]:
            return ret
    if w_r != None:    
        ret = common.default_weapon_abilities(w_r.ItemID) 
        Misc.SendMessage("Use right")
    return ret
       

#
def weaponspecials(weapon):
    if weapon == None:
        return None
    abilities = weapon_abilities()
    if abilities == None:
        return None
    primary = abilities[0]
    secondary = abilities[1]
    #Misc.SendMessage(primary)
    #Misc.SendMessage(secondary)
    if primary == None:
        return None
    if secondary == None:
        return None 
    primary_priority = 999   
    if primary in common.weapon_ability_priority:
        primary_priority = common.weapon_ability_priority[primary]
    secondary_priority = 999    
    if secondary in common.weapon_ability_priority:    
        secondary_priority = common.weapon_ability_priority[secondary]
    suggest_primary = 999
    suggest_secondary = 999
    #
    if not primary in common.requires_mount or Player.Mount != None:
        suggest_primary = primary_priority
    if not secondary in common.requires_mount or Player.Mount != None:
        suggest_secondary = secondary_priority
    if suggest_primary == 999 and suggest_secondary == 999:
        return None
    if suggest_primary < suggest_secondary:
        return Player.WeaponPrimarySA
    else:
        return Player.WeaponSecondarySA
#
def Use_weapon_special(weapon):
    #Misc.SendMessage("Action for 1")
    action = weaponspecials(weapon)
    if action != None and not Player.HasSpecial :
        #Misc.SendMessage("Do Action for 1")
        action()

next_provoke_time = 0
#
def provoke(enemy1, enemy2):
    global next_provoke_time
    Mobiles.Message(enemy1, 5, "Provoke 0x{:08x}".format(enemy1.Serial))
    Mobiles.Message(enemy2, 5, "Against 0x{:08x}".format(enemy2.Serial))
    instrumentID = 0xe9c
    drum = Items.FindByID(instrumentID, -1, Player.Backpack.Serial)
    if drum == None:
        return
    now = time.time()
    if next_provoke_time > time.time():
        return
    Journal.Clear()    
    Player.UseSkill('Provocation') 
    next_provoke_time = time.time() + 12
    journal_msg = ""
    limit = time.time() + 1
    while time.time() < limit:
        if Journal.Search("Whom do you"):
            journal_msg = "Whom do you"
            limit = 0  # force out of loop
        if Journal.Search("shall you play"):
            journal_msg = "shall you play"
            limit = 0  # force out of loop
    if journal_msg == "":
        Target.Cancel()
        return # wtf ?
    if journal_msg == "shall you play":
        Target.WaitForTarget(500)
        Target.TargetExecute(drum)
        Misc.Pause(100)
    Target.WaitForTarget(500)
    Target.TargetExecute(enemy1)
    Misc.Pause(500)
    Target.WaitForTarget(500)
    Target.TargetExecute(enemy2)
    Misc.Pause(500)
    Target.Cancel()
    return
    
def IsBoss(enemy):
    if enemy is None:
        return False
    name = enemy.Name
    bosses = ['Master', 'Neira', 'rikktor', 'semidar', 'mephitis' ]
    for boss in bosses:
       if boss.upper() in name.upper():
          return True
    return False      
  
    
Misc.ClearIgnore( )
if Misc.CheckSharedValue("Pets"):
    for pet in Misc.ReadSharedValue("Pets"):
        Misc.IgnoreObject(pet)


consecrate = 0
enemyOfOne = 0 
dont_kill = [ 'a dog', 'a cat', 'a horse', 'Dart', 'an energy vortex' ]
ignore_type = [0x007b ]
#0x0190, 0x0191, 
last_attack_msg = time.time()
last_attack_serial = 0
#
last_enemy = None
while True:
    #
    enemy_filter = Mobiles.Filter()
    enemy_filter.Enabled = True
    enemy_filter.RangeMin = -1
    if Misc.CheckSharedValue("MaxRange"):
        enemy_filter.RangeMax = Misc.ReadSharedValue("MaxRange")
    else:    
        enemy_filter.RangeMax = 11
    enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))

    on_me_filter = Mobiles.Filter()
    on_me_filter.Enabled = True
    on_me_filter.RangeMin = -1
    on_me_filter.RangeMax = 2
    on_me_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
    enemies = Mobiles.ApplyFilter(enemy_filter)
    up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
    #Misc.SendMessage("{} enemies up close".format(len(up_close_enemies)))
    
    w_r = Player.GetItemOnLayer('RightHand')
    #Misc.SendMessage("right={}".format(w_r))
    w_l = Player.GetItemOnLayer('LeftHand')
    #Misc.SendMessage("left={}".format(w_l))
    if w_l != None: 
        weapon = w_l
        Misc.Pause(500)
    elif w_r != None:    
        weapon = w_r
        Misc.Pause(500)
    else:
        weapon = None
    if not BandageHeal.Status():
        if Player.Poisoned or(Player.Hits < (Player.HitsMax * .8)):
            while Player.Poisoned or Player.Hits < (Player.HitsMax * .95):
                if len(enemies) > 0 and Player.WarMode:
                    if len(up_close_enemies) > 2:
                        action = whirlwind_available(weapon)
                        if action != None:
                            Misc.SendMessage("Whirlwind", 5)
                            action()
                        enemy = Mobiles.Select(enemies, "Weakest")
                        if enemy != None:
                            Player.Attack(enemy)
                            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                                Mobiles.Message(enemy, 5, "Heal Me & Attacking 0x{:08x}".format(enemy.Serial))
                                last_attack_msg = time.time()
                                last_attack_serial = enemy.Serial
                    common.HealMe(wait=False)
                    Misc.Pause(500)

                    #   Misc.SendMessage("Len before is {}".format(len(enemies)))
    #enemies_search = Mobiles.ApplyFilter(enemy_filter)
    #for e in enemies_search:
        #if e.Name in dont_kill:
            #enemies.Find(
            #enemies.Remove(e)
    #Misc.SendMessage("Len after is {}".format(len(enemies)))
    #on_me_filter.RangeMax = 2 
    #on_me_filter.Serials = enemies    
    
    #Misc.SendMessage("Up CLose Enemies after is {}".format(len(up_close_enemies)))
    if len(enemies) > 0:
        #Misc.SendMessage("{} enemies within 10 squares".format(len(enemies)))
        Player.SetWarMode(True)
        if len(up_close_enemies) > 0 and Player.WarMode:
            enemy = Mobiles.Select(up_close_enemies, 'Nearest')
        else:    
            enemy = Mobiles.Select(enemies, 'Nearest')
        if enemy.Name in dont_kill  or enemy.Body in ignore_type:
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        # ignore energy vortex
        if enemy and enemy.Body == 0x00A4 and enemy.Hue == 0:    
            Misc.IgnoreObject(enemy.Serial)
            enemy = None
        #if enemy == last_enemy or Player.InRangeMobile(enemy, 3):
            #pass
        #else:
            #Player.PathFindTo(enemy.Position.X, enemy.Position.Y, enemy.Position.Z)
            #last_enemy = enemy   
        if enemy != None:
            if last_attack_serial != enemy.Serial or time.time() > last_attack_msg + 5:
                Mobiles.Message(enemy, 5, "Attacking 0x{:08x}".format(enemy.Serial))
                last_attack_msg = time.time()
                last_attack_serial = enemy.Serial
            Player.Attack(enemy.Serial)
            #Target.AttackTargetFromList("attack")
            #Misc.SendMessage("Notoriety is {}".format(enemy.Notoriety)) 
            #Misc.SendMessage("{} Active".format(spell))
            #if len(enemies) > 1:  
            #    provoke(enemies[0], enemies[1])   
            if not Player.HasSpecial:
                w_r = Player.GetItemOnLayer('RightHand')
                #Misc.SendMessage("right={}".format(w_r))
                w_l = Player.GetItemOnLayer('LeftHand')
                #Misc.SendMessage("left={}".format(w_l))
                if w_l != None: 
                    weapon = w_l
                    Misc.Pause(500)
                elif w_r != None:    
                    weapon = w_r
                    Misc.Pause(500)
                else:
                    weapon = None
                #
                range = Items.GetPropValue(weapon, 'Range') 
                if range < 2:
                    range = 2         
                on_me_filter.RangeMax = range          
                up_close_enemies = Mobiles.ApplyFilter(on_me_filter)
                #
                num_up_close_enemies = len(up_close_enemies) 
                if IsBoss(enemy):
                    num_up_close_enemies = 1
                    #Use_weapon_special(weapon)
    #
    if not BandageHeal.Status() and not Misc.ScriptStatus('Heal_Me.py'):
        if Player.Poisoned or(Player.Hits < (Player.HitsMax * .95)):
            common.HealMe(wait=False)
    discord_list = {}    
#                      
    if Player.Weight > (.8 * Player.MaxWeight) or len(Player.Backpack.Contains) > 80 :
        Player.HeadMessage(1, "Heavy") 
    Misc.Pause(100)


